---
title: facil.io - API
sidebar: 0.6.x/_sidebar.md
---
# {{{title}}}

Although the facil.io includes extensive documentation within the source file, it's often helpful to have an overview the explains about a framework's idioms and general approach.

This is why, along side the actual API data, you will find explanations about facil.io's approach to memory "ownership" and similar topics that are consistent across the whole of the API.

The API sections are divided into:

* [Core Types API](types), which includes explanations about the facil.io dynamic object types (`FIOBJ`), Hash Maps, Dynamic Arrays and Linked Lists.

* [Modules API](modules), which includes explanations about the core `facil` library and the built-in modules and extensions, such as the CLI helper, the HTTP/Websocket protocols, the Pub/Sub engines etc'. 

### Your support is appreciated

facil.io started as a pet project. However, it seems facil.io grew to be bigger than I anticipated.

I am just one person and I have a limited amount of time to invest... which is why the documentation on this website is incomplete.

If you could help me copy the documentation from the source files and format it into markdown, it would be a great benefit for everyone using the facil.io framework.

It would also free my time so I could actually code more features and improve the existing code-base. After all, when I'm writing documentation I'm not coding.

Just visit the [GitHub repository](https://github.com/boazsegev/facil.io), fork and submit your PR. The documentation is all in the [`/docs` folder](https://github.com/boazsegev/facil.io/tree/master/docs) (which gets converted to HTML and becomes this beautiful website).
